;;; $Id: dic.scm,v 1.13 1995/07/29 14:07:04 skimu Exp $
;;; This is yet another interface to dserver, which provides
;;; online English Japanese dictionary.
;;;
;;; locale  ja_JP.eucJP ʤưʤ(Ȼפ)
(if (not (memq 'socket *features*))
    (load (in-vicinity (implementation-vicinity) "socket")))
(if (not (memq 'posix *features*))
    (load (in-vicinity (implementation-vicinity) "posix")))
(if (not (memq 'i/o-extentions *features*))
    (load (in-vicinity (implementation-vicinity) "ioext")))
;;(load (in-vicinity (implementation-vicinity) "rgx"))

(define dserver "komachi")
(define ndtp    2010)

;;;;======================================================================
;;;;
;;;; Socket ν
;;;;
;;; dserver ³(1:åȤĤʤ)
(define port
  (let ((p (socket:connect (make-stream-socket af_inet) 
			   (inet:string->address dserver)
			   ndtp)))
    (if (not p)
	(begin
	  (display "Could't connect dserver")
	  (quit)))
    p))

;;; Bufferd port 롣
;;; Хåե󥰤ʤ dserver ϰ
;;; ޥɤβ򤷤Ƥޤ
(define i-port (duplicate-port port "r"))
(define o-port (duplicate-port port "w"))

;;; 
(define send
  (lambda (mes p)
    (write-line mes p)
    (force-output p)))

;;; Լ
(define receive
  (lambda (p)
    (read-line p)))

;;;;======================================================================
;;;;
;;;; ndtp protocol
;;;;
(define dic:eiwa "eiwa")
(define dic:waei "waei")
(define current-alist '())
(define current-dic dic:eiwa)

;;; ڤؤ롣
;;; (change-dic dic:eiwa) or (change-dic dic:waei)
(define change-dic
  (lambda (dic)
    (send (string-append "L" dic) o-port)
    (receive i-port)
    (set! current-dic dic)))

;;; : (search pattern)
;;; pattern  string.
;;; pattern ĤС((key1 . index1) (key2 . index2) ...) ֤
;;; ĤʤС() ֤
(define search
  (letrec ((make-entry-alist
	    (lambda (al p)
	      (let ((s (receive p)))
		(if (string=? s "$$")
		    al
		    (make-entry-alist (append al (list (cons s (receive p))))
				      p))))))
    (lambda (pattern)
      (send (string-append "P" (if (string=? dic:eiwa current-dic)
				   "a"
				   "k")
			   pattern)
	    o-port)
      (receive i-port)
      (make-entry-alist '() i-port))))

;;; ʸμ: (get-body index alist-returned-by-search)
;;; ʸʸȤ֤

;;; get-body initial version
;;; ԤΤȤͤƤʤ
(define get-body-string
  (lambda (n al)
    (let ((idx (cdr (list-ref al n))))
      (send (string-append "S" idx) o-port)
      (receive i-port)
      (let ((b (receive i-port)))
	(receive i-port)
	b))))

(define format-command
  "sed -e 's/$/\\\n/' -e 's/\\005/\\\n/g' -e 's/\\0175/\\0175\\\n/g' -e 's/\\\[/\\\n\t\\\[/' -e 's/\\\]/\\\]\\\n\\\n/' -e 's//\\\n\\\n/g'  -e 's//\\\n\\\n/g' -e 's/\\( \\)\\([0-9][0-9]*\\)/\\\n\\\n\\2/g' -e 's/\\( \\)\\([a-z] \\)/\\\n\\\n\\2/g'  ")
;;(display format-command)

(define get-body
  (lambda (n al)
    (let* ((fname (let* ((str (get-body-string n al))
			 (fn  (tmpnam))
			 (fp  (open-file fn open_write)))
		    (display str fp)
		    (newline fp)
		    (close-port fp)
		    fn))
	   (pipe (open-input-pipe (string-append format-command fname))))
      (call-with-output-string
       (lambda (out)
	 (do ((c (read-char pipe) (read-char pipe)))
	     ((eof-object? c) (write-char #\nl out))
	   (write-char c out)))))))

;;; get-body եޥåȤ롣
(define get-body-format
  (lambda (n al)
    (let ((idx (cdr (list-ref al n))))
      (get-formatted-body idx))))

;;; string-append ǰʸ(1 Byte)Ťʸɲá٤
(define get-formatted-body-old
  (lambda (idx)
    (send (string-append "S" idx) o-port)
    (receive i-port)
    (let ((s (make-string 0)))
      (do ((c (read-char i-port) (read-char i-port)))
	  ((char=? c #\nl) (receive i-port) s)
	(case c
	  ((#\cr) (set! c #\nl))
	  ((#\bel) (set! c #\nl)))
	(set! s (string-append s (string c)))))))

;;; get-formatted-body second version.
(define run-off
  (lambda (s p)
    (let ((c (read-char p)))
      (if (not (char=? c #\nl))
	  (begin
	    (case c
	      ((#\cr) (set! c #\nl))
	      ((#\bel) (set! c #\nl)))
	    (set-cdr! s (list c))
	    (run-off (cdr s) p))
	  (receive p)))))
(define get-formatted-body-2
  (lambda (idx)
    (let ((sl '(#\nl)))
      (send (string-append "S" idx) o-port)
      (receive i-port)
      (run-off sl i-port)
      (apply string (cdr sl)))))

;;; get-formatted-body string-port version.
(define gfb:format
  (lambda (in out)
    (do ((c (read-char in) (read-char in)))
	((char=? c #\nl) (receive in))
      (case c
	((#\cr)  (write-char #\nl out))
	((#\bel) (write-char #\nl out))
	(else    (write-char c out))))))

(define get-formatted-body-string-port
  (lambda (idx)
    (send (string-append "S" idx) o-port)
    (receive i-port)
    (call-with-output-string (lambda (o)
			       (gfb:format i-port o)))))

;(define get-formatted-body get-formatted-body-old)
;(define get-formatted-body get-formatted-body-2)
(define get-formatted-body get-formatted-body-string-port)

;;;;======================================================================
;;;;
;;;; Scm äȤʴؿ
;;;;
(define disp-list
  (letrec ((disp-list-i
	    (lambda (al n)
	      (if (not (null? al))
		  (begin
		    (display n)
		    (display ". ")
		    (display (caar al))
		    (newline)
		    (disp-list-i (cdr al) (+ n 1)))))))
    (lambda (al)
      (disp-list-i al 0))))
(define s
  (lambda (pat)
    (set! current-alist (search pat))
    (disp-list current-alist)))
(define v
  (lambda (n)
    (get-body n current-alist)))

;;;;======================================================================
;;;;
;;;; dserver ³(2: ѵĤ)
;;;;
(begin
  (send (string-append "A" (getenv "USER"))  o-port)
  (if (char=? #\N
	   (do ((result (receive i-port) (receive i-port)))
	       ((char=? #\$ (string-ref result 0)) (string-ref result 1))))
      (begin
	(display "You cannot use dserver!")
	(newline)
	(quit)))
  (change-dic dic:eiwa))

;;;;======================================================================
;;;;
;;;; Athena Widget ˤ GUI
;;;;
(require 'xt)
(require 'xaw)

(let* ((top-level (xt:app-initialize "XScmTest" "dic"))
       (form  (xt:create-managed-widget "form"  xaw:form    top-level))
         ;;;;; Create  Widgets
       (title (xt:create-managed-widget "title" xaw:label      form))
       (eiwab (xt:create-managed-widget "eiwa"  xaw:toggle     form
;					xt:n-shape-style       xaw:shape-oval
;					xt:n-shape-style       xaw:shape-ellipse
					xt:n-from-horiz title))
       (waeib (xt:create-managed-widget "waei"  xaw:toggle     form
;					xt:n-shape-style       xaw:shape-oval
;					xt:n-shape-style       xaw:shape-ellipse
					xt:n-radio-group eiwab
					xt:n-from-horiz eiwab))
       (quitb (xt:create-managed-widget "Quit"  xaw:command    form
;					xt:n-shape-style       xaw:shape-oval
;					xt:n-shape-style       xaw:shape-ellipse
;					xt:n-shape-style       xaw:shape-rounded-rectangle
					xt:n-from-horiz        waeib))
       (Query (xt:create-managed-widget "Query" xaw:command    form
;					xt:n-shape-style       xaw:shape-ellipse
;					xt:n-shape-style       xaw:shape-oval
					xt:n-from-vert         title))
       (word  (xt:create-managed-widget "word"  xaw:ascii-text form
					xt:n-edit-type         xaw:text-edit
					xt:n-resize            #f
					xt:n-from-horiz        Query
					xt:n-from-vert         title))
       (candv (xt:create-managed-widget "candv" xaw:viewport   form
					xt:n-from-vert         Query
					xt:n-height            300
					xt:n-width             100
					xt:n-allow-vert        #t
					xt:n-force-bars        #t))
       (text  (xt:create-managed-widget "text"  xaw:ascii-text form
					xt:n-edit-type         xaw:text-read
					xt:n-scroll-vertical   xaw:text-scroll-always
					xt:n-wrap              xaw:text-wrap-word
					xt:n-height            300
					xt:n-width             600
					xt:n-from-horiz        candv
					xt:n-from-vert         word))
       (candl (xt:create-managed-widget "candl" xaw:list       candv
					xt:n-list (stringvector "")
					xt:n-vertical-list     #t
					xt:n-force-columns     #t
					xt:n-default-columns   1))
         ;;;; Callbacks
       (set-cand-list (let ((v '()))
			(lambda (x l)
			  (set! v (list->stringvector x))
			  (xt:set-values candl xt:n-list v
					       xt:n-number-strings l))))
       (create-cand (lambda ()
		      (let* ((len (length current-alist))
			     (v   '()))
			(do ((i 0 (+ i 1)))
			    ((>= i len))
			  (set! v (cons (car (list-ref current-alist i)) v)))
			(set-cand-list v len))))
       (do-candl (lambda (w)
		   (let ((indx (cdr (xaw:list-show-current w))))
		     (xt:set-values
		      text 
		      xt:n-string (get-body indx 
					    current-alist)))))
       (do-query (lambda (w)
		   (let* ((pat (xt:get-value word xt:n-string xt:string)))
		     (set! current-alist (search pat))
		     (if (not (null? current-alist))
			 (begin
			   (create-cand)
			   (xt:set-values
			    text xt:n-string (get-body 0 
						       current-alist))))))))
  (xt:add-callback eiwab xt:n-callback (lambda (w) (change-dic dic:eiwa)))
  (xt:add-callback waeib xt:n-callback (lambda (w) (change-dic dic:waei)))
  (xt:add-callback quitb xt:n-callback (lambda (w) (quit)))
  (xt:add-callback Query xt:n-callback do-query)
  (xt:add-callback candl xt:n-callback do-candl)
  (xt:install-accelerators word Query)
  (xt:realize-widget top-level)
  (xt:app-main-loop)))
(display "setup done")(newline)
