;;; $Id: pixmap.scm,v 1.10 1995/09/01 03:02:31 skimu Exp $
;;; Pixmap Viewer.
;;;
(require 'xt)
(require 'xaw)
(require 'xpm)

(if (not (memq 'posix *features*))
    (load (in-vicinity (implementation-vicinity) "posix")))
(if (not (memq 'i/o-extentions *features*))
    (load (in-vicinity (implementation-vicinity) "ioext")))

(define bitmap-dir "/usr/X11R6/include/X11/pixmaps/")
;;(define bitmap-dir "/src/Xmt/contrib/pixmaps/")
(define say
  (lambda mes
    (display (apply string-append mes))
    (newline)))

(define system-with-list-of-output-string
  (letrec ((loop (lambda (l p)
		   (let ((str (read-line p)))
		     (if (eof-object? str)
			 l
			 (begin
			   (set-cdr! l (list str))
			   (loop (cdr l) p)))))))
    (lambda (command)
      (let* ((pipe (open-input-pipe command))
	     (str (read-line pipe))
	     (ret (list str)))
	(if (eof-object? str)
	    '()
	    (begin
	      (loop ret pipe)
	      ret))))))
(define system/loos system-with-list-of-output-string)


(define bitmap-file 
  (system/loos (string-append "ls " bitmap-dir "*")))

(define *the-pixmap* '()) ; last pixmap

(define create-pixmaps
  (lambda (fname display)
    (let ((loop (lambda (n)
		  (let ((pm (xpm:read-file-to-pixmap display
						    (x:default-root-window display)
						    n)))
		    (set! *the-pixmap* pm)
		    (car pm)))))
      (map loop fname))))

(define top-level (xt:app-initialize "XScmTest" "pixmap"))
(define the-display (xt:display top-level))

(define create-commands
  (lambda (pixmaps bitmaps parent)
    (let ((loop (lambda (p b)
		  (let ((w (xt:create-managed-widget b xaw:command parent
						     xt:n-bitmap p)))
		    (xt:add-callback w xt:n-callback (lambda (w)
;						       (xpm:write-file-from-pixmap the-display
;										   "fou.xpm"
;										   (car *the-pixmap*)
;										   (cdr *the-pixmap*))
						       (say "This is " b "!")
						       (display (x:get-geometry 
								the-display (xt:window w) 1))
						       (newline)))))))
      (map loop pixmaps bitmaps))))

(let* ((form      (xt:create-managed-widget "form" xaw:form top-level))
       (title     (xt:create-managed-widget "title" xaw:label form))
       (quitb     (xt:create-managed-widget "Quit"  xaw:command form
					    xt:n-from-horiz title))
       (viewport  (xt:create-managed-widget "Viewport" xaw:viewport form
					    xt:n-from-vert  title
       					    xt:n-width 200
					    xt:n-height 200
					    xt:n-allow-vert  #t
					    xt:n-allow-horiz #t
					    xt:n-force-bars  #t))
       (box       (xt:create-managed-widget "Box"       xaw:box      viewport))
       (pixes     (create-pixmaps bitmap-file (xt:display top-level))))
  (create-commands pixes bitmap-file box)
  (xt:add-callback quitb xt:n-callback (lambda (w) (quit)))
  (xt:realize-widget top-level)
  (xt:app-main-loop))
