;; $Id: textentry.scm,v 1.5 1995/08/05 13:16:05 skimu Exp $
;;
(require 'xt)
(require 'xaw)

(define top-level (xt:app-initialize "XScmTest" "textentry"))

(let* ((box      (xt:create-managed-widget
		  "box"  xaw:box top-level))
       (pressme  (xt:create-managed-widget
		  "pressme" xaw:command box))
       (quitb     (xt:create-managed-widget
		   "quit" xaw:command   box))
       (pshell   (xt:create-managed-widget 
		  "pshell" xt:transient-shell top-level
		  xt:n-allow-shell-resize #t
		  xt:n-transient-for      top-level))
       (form     (xt:create-managed-widget
		  "form" xaw:form pshell))
       (label    (xt:create-managed-widget
		  "label" xaw:label form
		  xt:n-border-width 0))
       (address1 (xt:create-managed-widget
		  "address1"xaw:ascii-text form
		  xt:n-edit-type 2
		  xt:n-scroll-vertical xaw:text-scroll-always
		  xt:n-resizable #t
		  xt:n-resize xaw:text-resize-never
		  xt:n-from-vert label
		  xt:n-height 100
		  xt:n-right 3
		  xt:n-left 2))
       (address2 (xt:create-managed-widget
		  "address2" xaw:ascii-text form
		  xt:n-edit-type 2
		  xt:n-resizable #t
		  xt:n-resize xaw:text-resize-both
		  xt:n-from-vert address1
		  xt:n-right 3
		  xt:n-left 2))
       (dialog-done   (xt:create-managed-widget
		       "dialogDone" xaw:command form
		       xt:n-from-vert address2
		       xt:n-bottom xaw:chain-bottom))
       (dialog-cancel (xt:create-managed-widget
		       "dialogCancel" xaw:command form
		       xt:n-from-vert address2
		       xt:n-from-horiz dialog-done
		       xt:n-bottom xaw:chain-bottom))
       (dialog-done-CB
	(lambda (w)
	  (xt:popdown pshell)
	  (xt:set-sensitive pressme #t)
	  (xt:set-sensitive quitb #t)
	  (let ((string1 (xt:get-value address1
				       xt:n-string xt:string))
		(string2 (xt:get-value address2
				       xt:n-string xt:string)))
	    (display (string-append "Users's address is:"
				    string1 string2))
	    (newline))))
       (dialog-cancel-CB
	(lambda (w)
	  (xt:popdown pshell)
	  (xt:set-sensitive pressme #t)
	  (xt:set-sensitive quitb #t)))
       (popup-dialog
	(lambda (w)
	  (let ((width  (xt:get-value top-level
				      xt:n-width xt:short))
		(height (xt:get-value top-level
				      xt:n-height xt:short)))
	    (xt:set-values pshell
			   xt:n-x width
			   xt:n-y height
			   xt:n-width 200
			   xt:n-height 100)
	    (xt:set-sensitive pressme #f)
	    (xt:set-sensitive quitb #f)
	    (xt:popup pshell 1)))))
  (xt:add-callback dialog-done   xt:n-callback dialog-done-CB)
  (xt:add-callback dialog-cancel xt:n-callback dialog-cancel-CB)
  (xt:add-callback quitb         xt:n-callback (lambda (w) (quit)))
  (xt:add-callback pressme       xt:n-callback popup-dialog)
  (xt:realize-widget top-level)
  (xt:app-main-loop))
