;;; $Id: tree.scm,v 1.6 1995/08/05 13:17:18 skimu Exp $
;;; Example for Tree Wiget.
;;;
(require 'xt)
(require 'xaw)

(define the-tree '("foo"
		   ("a" "b" "c")
		   ("moo" "uoo" ("bar" "baz") "hoge")
		   "helo"
		   ("g" "e" ("f" "h" ("o" "1") "2" "3" "4"))))
(define another-tree '("foo" ("moo" "uoo" ("bar" "baz")) "fou"))

(define say
  (lambda mes
    (display (apply string-append mes))
    (newline)))

(define create-tree
  (lambda (name p tree)
    (letrec ((create-leaf
	      (lambda (parent leaf)
		(if (pair? leaf)
		    (let ((b (xt:create-managed-widget
			      "branch" xaw:label p
			      xt:n-tree-parent parent)))
		      (create-leaves b leaf))
		    (let ((c (xt:create-managed-widget
			      leaf xaw:command p
			      xt:n-tree-parent parent)))
		      (xt:add-callback c xt:n-callback
				       (lambda (w)
					 (say "This is \"" leaf "\"!")))))))
	     (create-leaves
	      (lambda (parent leaves)
		(if (null? leaves)
		    parent
		    (begin
		      (create-leaf  parent (car leaves))
		      (create-leaves parent (cdr leaves)))))))
      (let ((root (xt:create-managed-widget name xaw:command p)))
	(create-leaves root tree)))))
			     
(define top-level (xt:app-initialize "XScmTest" "tree"))
(let* ((vp (xt:create-managed-widget "View" xaw:viewport top-level
				     xt:n-height      200
				     xt:n-allow-vert  #t
				     xt:n-allow-horiz #t
				     xt:n-force-bars  #t))
       (tree (xt:create-managed-widget "Tree" xaw:tree vp))
       (root (create-tree "root" tree the-tree))
       (toor (create-tree "toor" tree another-tree)))
  (xt:add-callback root xt:n-callback
		   (lambda (w)
		     (say "Good Bye!")
		     (quit)))
  (xt:add-callback toor xt:n-callback
		   (lambda (w)
		     (say "Please push \"root\" button to quit.")))
  (xt:realize-widget top-level)
  (xt:app-main-loop))

