;;;
;;;  Expands define-widget macro
;;;
;;;  @(#)widgetex.scm 1.0.0 94/02/15 (Shiro Kawai, kawai@sail.t.u-tokyo.ac.jp)
;;;  Copyright (C) 1993 by Shiro Kawai

;; Usage:
;;   scm widgetex.scm < source-file > output-file
;;
;; Expands all syntaxes to make execution faster.

(require 'macro)
(require 'pretty-print)

(macro:load "widget.scm")

(define (widget-compile pp?)
  (let loop ((form (read)))
    (if (eof-object? form)
	(quit)
	(let ((expand (macro:expand form)))
	  (if pp?
	      (pretty-print expand)
	      (write expand))
	  (newline)
	  (loop (read))))))

(widget-compile #t)
