(require 'repl)

(load (in-vicinity (implementation-vicinity) "ioext"))

(load (in-vicinity (implementation-vicinity) "posix"))

(require
  (in-vicinity (library-vicinity) "x11.scm"))

(require
  (in-vicinity (library-vicinity) "xt.scm"))

(require
  (in-vicinity (library-vicinity) "xevent.scm"))

(require
  (in-vicinity (library-vicinity) "xaw.scm"))

(define *editing-file* #f)

(define main-window
  (let ((self|4|5 #f))
    (lambda (parent|4|6)
      (if self|4|5
        self|4|5
        (begin
          (set! self|4|5
            (xt:create-managed-widget
              "main-window"
              xaw:paned
              parent|4|6
              xt:n-width
              600))
          (let* ((child|4|9
                   (cons (menu-bar self|4|5)
                         (cons (text-pane self|4|5) '()))))
            (begin '() '() self|4|5)))))))

(define menu-bar
  (let ((self|4|5 #f))
    (lambda (parent|4|6)
      (if self|4|5
        self|4|5
        (begin
          (set! self|4|5
            (xt:create-managed-widget
              "menu-bar"
              xaw:box
              parent|4|6
              xt:n-orientation
              "horizontal"))
          (let* ((child|4|9
                   (cons ((let ((self|14|15 #f))
                            (lambda (parent|14|16)
                              (if self|14|15
                                self|14|15
                                (begin
                                  (set! self|14|15
                                    (xt:create-managed-widget
                                      "file-button"
                                      xaw:menu-button
                                      parent|14|16
                                      xt:n-menu-name
                                      "file-menu"
                                      xt:n-label
                                      "File"))
                                  (let* ((child|14|20 '()))
                                    (begin
                                      '()
                                      (begin
                                        ((lambda (self|24 child|24)
                                           (file-menu self|24))
                                         self|14|15
                                         child|14|20)
                                        '())
                                      self|14|15))))))
                          self|4|5)
                         (cons ((let ((self|30|31 #f))
                                  (lambda (parent|30|32)
                                    (if self|30|31
                                      self|30|31
                                      (begin
                                        (set! self|30|31
                                          (xt:create-managed-widget
                                            "search-button"
                                            xaw:command
                                            parent|30|32
                                            xt:n-label
                                            "Search"))
                                        (let* ((child|30|35 '()))
                                          (begin
                                            (xt:add-callback
                                              self|30|31
                                              xt:n-callback
                                              (lambda (w|38)
                                                (warn "Sorry, not implemented yet")))
                                            '()
                                            '()
                                            self|30|31))))))
                                self|4|5)
                               '()))))
            (begin '() '() self|4|5)))))))

(define file-menu
  (let ((self|4|5 #f))
    (lambda (parent|4|6)
      (if self|4|5
        self|4|5
        (begin
          (set! self|4|5
            (xt:create-popup-shell
              "file-menu"
              xaw:simple-menu
              parent|4|6))
          (let* ((child|4|8
                   (cons ((let ((self|13|14 #f))
                            (lambda (parent|13|15)
                              (if self|13|14
                                self|13|14
                                (begin
                                  (set! self|13|14
                                    (xt:create-managed-widget
                                      "open"
                                      xaw:sme-bsb
                                      parent|13|15
                                      xt:n-label
                                      "open"))
                                  (let* ((child|13|18 '()))
                                    (begin
                                      (xt:add-callback
                                        self|13|14
                                        xt:n-callback
                                        (lambda (w|21)
                                          (xt:popup
                                            (file-open-w toplevel-w)
                                            2)))
                                      '()
                                      '()
                                      self|13|14))))))
                          self|4|5)
                         (cons ((let ((self|28|29 #f))
                                  (lambda (parent|28|30)
                                    (if self|28|29
                                      self|28|29
                                      (begin
                                        (set! self|28|29
                                          (xt:create-managed-widget
                                            "save"
                                            xaw:sme-bsb
                                            parent|28|30
                                            xt:n-label
                                            "save"))
                                        (let* ((child|28|33 '()))
                                          (begin
                                            (xt:add-callback
                                              self|28|29
                                              xt:n-callback
                                              (lambda (w|36)
                                                (if *editing-file*
                                                  (if (xaw:ascii-save
                                                        *editing-file*)
                                                    '()
                                                    (warn "Save Failed.")))))
                                            '()
                                            '()
                                            self|28|29))))))
                                self|4|5)
                               (cons ((let ((self|43|44 #f))
                                        (lambda (parent|43|45)
                                          (if self|43|44
                                            self|43|44
                                            (begin
                                              (set! self|43|44
                                                (xt:create-managed-widget
                                                  "interpreter"
                                                  xaw:sme-bsb
                                                  parent|43|45
                                                  xt:n-label
                                                  "interpreter"))
                                              (let* ((child|43|48 '()))
                                                (begin
                                                  (xt:add-callback
                                                    self|43|44
                                                    xt:n-callback
                                                    (lambda (w|51)
                                                      (begin
                                                        (display
                                                          "### interpreter invoked")
                                                        (newline)
                                                        (display
                                                          "    (repl:quit) to exit")
                                                        (newline)
                                                        (repl:top-level
                                                          slib:eval))))
                                                  '()
                                                  '()
                                                  self|43|44))))))
                                      self|4|5)
                                     (cons ((let ((self|58|59 #f))
                                              (lambda (parent|58|60)
                                                (if self|58|59
                                                  self|58|59
                                                  (begin
                                                    (set! self|58|59
                                                      (xt:create-managed-widget
                                                        "quit"
                                                        xaw:sme-bsb
                                                        parent|58|60
                                                        xt:n-label
                                                        "quit"))
                                                    (let* ((child|58|63 '()))
                                                      (begin
                                                        (xt:add-callback
                                                          self|58|59
                                                          xt:n-callback
                                                          (lambda (w|66)
                                                            (query "Quit OK?"
                                                                   (lambda (w|67)
                                                                     (quit)))))
                                                        '()
                                                        '()
                                                        self|58|59))))))
                                            self|4|5)
                                           '()))))))
            (begin '() '() self|4|5)))))))

(define file-open-w
  (let ((self|5|6 #f))
    (lambda (parent|5|7)
      (if self|5|6
        self|5|6
        (begin
          (set! self|5|6
            (xt:create-popup-shell
              "file-open-w"
              xt:transient-shell
              parent|5|7))
          (let* ((child|5|9
                   (cons ((lambda (parent|11)
                            (fsb parent|11
                                 (lambda (s|12)
                                   (begin
                                     (xt:popdown (file-open-w #t))
                                     (open-text-file s|12)))
                                 (lambda () (xt:popdown (file-open-w #t)))))
                          self|5|6)
                         '())))
            (begin
              '()
              (begin
                ((lambda (self|17 child|17) (center self|17))
                 self|5|6
                 child|5|9)
                '())
              self|5|6)))))))

(define text-pane
  (let ((self|3|4 #f))
    (lambda (parent|3|5)
      (if self|3|4
        self|3|4
        (begin
          (set! self|3|4
            (xt:create-managed-widget
              "text-pane"
              xaw:ascii-text
              parent|3|5
              xt:n-scroll-vertical
              xaw:text-scroll-always
              xt:n-scroll-horizontal
              xaw:text-scroll-when-needed
              xt:n-preferred-pane-size
              200
              xt:n-display-caret
              #f))
          (let* ((child|3|11 '()))
            (begin '() '() self|3|4)))))))

(define open-text-file
  (lambda (filename|1)
    (let ((src|2 ((let ((self|5|6 #f))
                    (lambda (parent|5|7)
                      (if self|5|6
                        self|5|6
                        (begin
                          (set! self|5|6
                            (xt:create-managed-widget
                              "asciisrc"
                              xaw:multi-src-object
                              parent|5|7
                              xt:n-string
                              filename|1
                              xt:n-type
                              xaw:ascii-file))
                          (let* ((child|5|11 '()))
                            (begin '() '() self|5|6))))))
                  toplevel-w)))
      (begin
        (set! *editing-file* src|2)
        (xaw:text-set-source (text-pane #f) src|2 0)
        (xaw:text-display-caret (text-pane #f) #t)
        (xt:set-values
          (text-pane #f)
          xt:n-edit-type
          xaw:text-edit)))))

(define fsb
  (lambda (parent|1 apply-proc|1 cancel-proc|1)
    (letrec ((fsb-selection|3
               (let ((self|7|8 #f))
                 (lambda (parent|7|9)
                   (if self|7|8
                     self|7|8
                     (begin
                       (set! self|7|8
                         (xt:create-managed-widget
                           "selection"
                           xaw:ascii-text
                           parent|7|9
                           xt:n-skip-adjust
                           #t
                           xt:n-resize
                           xaw:text-resize-width
                           xt:n-length
                           30
                           xt:n-edit-type
                           xaw:text-edit))
                       (let* ((child|7|15 '()))
                         (begin
                           '()
                           (begin
                             ((lambda (self|19 child|19)
                                (let ((source|20
                                        (xaw:text-get-source self|19)))
                                  (xt:add-callback
                                    source|20
                                    xt:n-callback
                                    cr-handler|3)))
                              self|7|8
                              child|7|15)
                             '())
                           self|7|8)))))))
             (fsb-list|3
               (let ((self|25|26 #f))
                 (lambda (parent|25|27)
                   (if self|25|26
                     self|25|26
                     (begin
                       (set! self|25|26
                         (xt:create-managed-widget
                           "list"
                           xaw:list
                           parent|25|27
                           xt:n-force-columns
                           #t
                           xt:n-default-columns
                           1
                           xt:n-list
                           (fsb-get-directory|3 "")))
                       (let* ((child|25|32 '()))
                         (begin
                           '()
                           (begin
                             ((lambda (self|36 child|36)
                                (xaw:add-callback
                                  self|36
                                  xaw:list-callback
                                  (lambda (w|37 item|37 . fo|37)
                                    (xt:set-values
                                      (fsb-selection|3 #t)
                                      xt:n-string
                                      item|37))))
                              self|25|26
                              child|25|32)
                             '())
                           self|25|26)))))))
             (fsb-viewport|3
               (let ((self|43|44 #f))
                 (lambda (parent|43|45)
                   (if self|43|44
                     self|43|44
                     (begin
                       (set! self|43|44
                         (xt:create-managed-widget
                           "viewport"
                           xaw:viewport
                           parent|43|45
                           xt:n-skip-adjust
                           #f
                           xt:n-preferred-pane-size
                           150
                           xt:n-force-bars
                           #t
                           xt:n-allow-vert
                           #t))
                       (let* ((child|43|51 (cons (fsb-list|3 self|43|44) '())))
                         (begin
                           '()
                           (begin
                             ((lambda (self|56 child|56)
                                (xt:set-values self|56 xt:n-height 120))
                              self|43|44
                              child|43|51)
                             '())
                           self|43|44)))))))
             (fsb-get-directory|3
               (lambda (prefix|58)
                 (let* ((p|59 (open-pipe
                                (string-append "ls -aF " prefix|58)
                                "r"))
                        (l|60 (let loop|62 ((item|61 (read-line p|59)))
                                (if (eof-object? item|61)
                                  '()
                                  (cons (string-append prefix|58 item|61)
                                        (loop|62 (read-line p|59)))))))
                   (begin (close-port p|59) (list->vector l|60)))))
             (cr-handler|3
               (lambda (w|63)
                 (let* ((s|64 (xt:get-value w|63 xt:n-string xt:string))
                        (len|65 (string-length s|64)))
                   (if (and (> len|65 0)
                            (char=? (string-ref s|64 (- len|65 1)) #\newline))
                     (begin
                       (xt:set-values
                         w|63
                         xt:n-string
                         (substring s|64 0 (- len|65 1)))
                       (fsb-select|3))))))
             (fsb-select|3
               (lambda ()
                 (let ((selected|67
                         (xt:get-value
                           (fsb-selection|3 #f)
                           xt:n-string
                           xt:string)))
                   (if (= (string-length selected|67) 0)
                     '()
                     (case (string-ref
                             selected|67
                             (- (string-length selected|67) 1))
                       ((#\/)
                        (xaw:list-change
                          (fsb-list|3 #t)
                          (fsb-get-directory|3 selected|67)
                          #f
                          #t))
                       ((#\@ #\*)
                        (apply-proc|1
                          (substring
                            selected|67
                            0
                            (- (string-length selected|67) 1))))
                       (else (apply-proc|1 selected|67))))))))
      ((let ((self|71|72 #f))
         (lambda (parent|71|73)
           (if self|71|72
             self|71|72
             (begin
               (set! self|71|72
                 (xt:create-managed-widget
                   "fsb"
                   xaw:paned
                   parent|71|73))
               (let* ((child|71|75
                        (cons ((let ((self|79|80 #f))
                                 (lambda (parent|79|81)
                                   (if self|79|80
                                     self|79|80
                                     (begin
                                       (set! self|79|80
                                         (xt:create-managed-widget
                                           "label"
                                           xaw:label
                                           parent|79|81
                                           xt:n-skip-adjust
                                           #t
                                           xt:n-border-width
                                           0
                                           xt:n-label
                                           "Selection:"))
                                       (let* ((child|79|86 '()))
                                         (begin '() '() self|79|80))))))
                               self|71|72)
                              (cons (fsb-selection|3 self|71|72)
                                    (cons (fsb-viewport|3 self|71|72)
                                          (cons ((let ((self|96|97 #f))
                                                   (lambda (parent|96|98)
                                                     (if self|96|97
                                                       self|96|97
                                                       (begin
                                                         (set! self|96|97
                                                           (xt:create-managed-widget
                                                             "commands"
                                                             xaw:box
                                                             parent|96|98
                                                             xt:n-skip-adjust
                                                             #t
                                                             xt:n-orientation
                                                             "horizontal"))
                                                         (let* ((child|96|102
                                                                  (cons ((let ((self|107|108
                                                                                 #f))
                                                                           (lambda (parent|107|109)
                                                                             (if self|107|108
                                                                               self|107|108
                                                                               (begin
                                                                                 (set! self|107|108
                                                                                   (xt:create-managed-widget
                                                                                     "apply"
                                                                                     xaw:command
                                                                                     parent|107|109
                                                                                     xt:n-label
                                                                                     "Apply"))
                                                                                 (let* ((child|107|112
                                                                                          '()))
                                                                                   (begin
                                                                                     (xt:add-callback
                                                                                       self|107|108
                                                                                       xt:n-callback
                                                                                       (lambda (w|115)
                                                                                         (fsb-select|3)))
                                                                                     '()
                                                                                     '()
                                                                                     self|107|108))))))
                                                                         self|96|97)
                                                                        (cons ((let ((self|122|123
                                                                                       #f))
                                                                                 (lambda (parent|122|124)
                                                                                   (if self|122|123
                                                                                     self|122|123
                                                                                     (begin
                                                                                       (set! self|122|123
                                                                                         (xt:create-managed-widget
                                                                                           "cancel"
                                                                                           xaw:command
                                                                                           parent|122|124
                                                                                           xt:n-label
                                                                                           "Cancel"))
                                                                                       (let* ((child|122|127
                                                                                                '()))
                                                                                         (begin
                                                                                           (xt:add-callback
                                                                                             self|122|123
                                                                                             xt:n-callback
                                                                                             (lambda (w|130)
                                                                                               (cancel-proc|1)))
                                                                                           '()
                                                                                           '()
                                                                                           self|122|123))))))
                                                                               self|96|97)
                                                                              '()))))
                                                           (begin
                                                             '()
                                                             '()
                                                             self|96|97))))))
                                                 self|71|72)
                                                '()))))))
                 (begin
                   '()
                   (begin
                     ((lambda (self|139 children|139)
                        (map (lambda (w|140)
                               (xt:set-values w|140 xt:n-show-grip #f))
                             children|139))
                      self|71|72
                      child|71|75)
                     '())
                   self|71|72))))))
       parent|1))))

(define center
  (lambda (w|1)
    (let ((top-x|2
            (xt:get-value toplevel-w xt:n-x xt:short))
          (top-y|2
            (xt:get-value toplevel-w xt:n-y xt:short))
          (top-w|2
            (xt:get-value toplevel-w xt:n-width xt:short))
          (top-h|2
            (xt:get-value toplevel-w xt:n-height xt:short))
          (pop-w|2 (xt:get-value w|1 xt:n-width xt:short))
          (pop-h|2 (xt:get-value w|1 xt:n-height xt:short)))
      (xt:set-values
        w|1
        xt:n-x
        (inexact->exact
          (+ top-x|2 (/ (- top-w|2 pop-w|2) 2)))
        xt:n-y
        (inexact->exact
          (+ top-y|2 (/ (- top-h|2 pop-h|2) 2)))))))

(define warn
  (lambda (msg|1)
    (letrec ((warn-dialog|2
               (let ((self|6|7 #f))
                 (lambda (parent|6|8)
                   (if self|6|7
                     self|6|7
                     (begin
                       (set! self|6|7
                         (xt:create-managed-widget
                           "warn-dialog"
                           xaw:dialog
                           parent|6|8
                           xt:n-label
                           ""))
                       (let* ((child|6|11
                                (cons ((let ((self|16|17 #f))
                                         (lambda (parent|16|18)
                                           (if self|16|17
                                             self|16|17
                                             (begin
                                               (set! self|16|17
                                                 (xt:create-managed-widget
                                                   "ok"
                                                   xaw:command
                                                   parent|16|18
                                                   xt:n-label
                                                   "OK"))
                                               (let* ((child|16|21 '()))
                                                 (begin
                                                   (xt:add-callback
                                                     self|16|17
                                                     xt:n-callback
                                                     (lambda (w|24)
                                                       (xt:popdown
                                                         (warn-shell|2
                                                           toplevel-w))))
                                                   '()
                                                   '()
                                                   self|16|17))))))
                                       self|6|7)
                                      '())))
                         (begin '() '() self|6|7)))))))
             (warn-shell|2
               (let ((self|33|34 #f))
                 (lambda (parent|33|35)
                   (if self|33|34
                     self|33|34
                     (begin
                       (set! self|33|34
                         (xt:create-popup-shell
                           "warning"
                           xt:transient-shell
                           parent|33|35))
                       (let* ((child|33|37
                                (cons (warn-dialog|2 self|33|34) '())))
                         (begin '() '() self|33|34))))))))
      (begin
        (xt:set-values
          (warn-dialog|2 (warn-shell|2 toplevel-w))
          xt:n-label
          msg|1)
        (center (warn-shell|2 toplevel-w))
        (xt:popup (warn-shell|2 toplevel-w) 2)))))

(define query
  (lambda (msg|1 ok-proc|1)
    (letrec ((query-dialog|2
               (let ((self|6|7 #f))
                 (lambda (parent|6|8)
                   (if self|6|7
                     self|6|7
                     (begin
                       (set! self|6|7
                         (xt:create-managed-widget
                           "query-dialog"
                           xaw:dialog
                           parent|6|8
                           xt:n-label
                           ""))
                       (let* ((child|6|11
                                (cons ((let ((self|16|17 #f))
                                         (lambda (parent|16|18)
                                           (if self|16|17
                                             self|16|17
                                             (begin
                                               (set! self|16|17
                                                 (xt:create-managed-widget
                                                   "ok"
                                                   xaw:command
                                                   parent|16|18
                                                   xt:n-label
                                                   "OK"))
                                               (let* ((child|16|21 '()))
                                                 (begin
                                                   (xt:add-callback
                                                     self|16|17
                                                     xt:n-callback
                                                     ok-proc|1)
                                                   '()
                                                   '()
                                                   self|16|17))))))
                                       self|6|7)
                                      (cons ((let ((self|30|31 #f))
                                               (lambda (parent|30|32)
                                                 (if self|30|31
                                                   self|30|31
                                                   (begin
                                                     (set! self|30|31
                                                       (xt:create-managed-widget
                                                         "cancel"
                                                         xaw:command
                                                         parent|30|32
                                                         xt:n-label
                                                         "Cancel"))
                                                     (let* ((child|30|35 '()))
                                                       (begin
                                                         (xt:add-callback
                                                           self|30|31
                                                           xt:n-callback
                                                           (lambda (w|38)
                                                             (xt:popdown
                                                               (query-shell|2
                                                                 toplevel-w))))
                                                         '()
                                                         '()
                                                         self|30|31))))))
                                             self|6|7)
                                            '()))))
                         (begin '() '() self|6|7)))))))
             (query-shell|2
               (let ((self|47|48 #f))
                 (lambda (parent|47|49)
                   (if self|47|48
                     self|47|48
                     (begin
                       (set! self|47|48
                         (xt:create-popup-shell
                           "query"
                           xt:transient-shell
                           parent|47|49))
                       (let* ((child|47|51
                                (cons (query-dialog|2 self|47|48) '())))
                         (begin '() '() self|47|48))))))))
      (begin
        (xt:set-values
          (query-dialog|2 (query-shell|2 toplevel-w))
          xt:n-label
          msg|1)
        (center (query-shell|2 toplevel-w))
        (xt:popup (query-shell|2 toplevel-w) 2)))))

(define toplevel-w
  (if (defined? vs:top-level)
    (xt:app-create-shell
      "shell"
      "Shell"
      xt:application-shell
      (xt:display vs:top-level))
    (xt:initialize "xawsample" "XAwsample")))

(xt:set-values
  toplevel-w
  xt:n-title
  "Scheme with Athena Widget")

(main-window toplevel-w)

(xt:realize-widget toplevel-w)

(xt:main-loop #t)

