/*
 * $Id: xt.h,v 1.2 1995/09/01 12:52:23 skimu Exp $
 * Modified for X11R6 by Shigenobu Kimura (skimu@izanagi.phys.s.u-tokyo.ac.jp)
 * Author: Larry Campbell (campbell@world.std.com)
 *
 * Copyright 1992 by The Boston Software Works, Inc.
 * Permission to use for any purpose whatsoever granted, as long
 * as this copyright notice remains intact.  Please send bug fixes
 * or enhancements to the above email address.
 *
 * X Toolkit interface for scm - common definitions
 */

typedef struct {
    char	*wc_name;
    WidgetClass	*wc_class;
} xt_widget_class_t;

#define WIDGETP(x) (TYP16(x) == tc16_widget)
#define WIDGET(x) ((Widget) CDR(x))
#define WIDGETCLASSP(x) (TYP16(x) == tc16_widget_class)
#define WIDGETCLASS(x) ((WidgetClass) CDR(x))
#ifdef MOTIF
#define XMSTRINGP(x) (TYP16(x) == tc16_xmstring)
#define XMSTRING(x) ((XmString) CDR(x))
#define XMSTRINGTABLEP(x) (TYP16(x) == tc16_xmstringtable)
#define XMSTRINGTABLE(x) ((XmStringTable) CDR(x))
#define XMSTRINGTABLE_LENGTH(x) (CAR(x)>>16)
#define SET_XMSTRINGTABLE_LENGTH(x,v,t) CAR(x) = ((v)<<16)+t
#endif /* MOTIF */

extern SCM	 make_widget P((Widget w));
extern SCM	 make_widget_class P((WidgetClass wc));
extern void	 xt_init_widget_classes P((xt_widget_class_t table[],
					   int count, char *listname));

extern long	 tc16_widget;
#ifdef MOTIF
extern long	 tc16_xmstring;
extern long	 tc16_xmstringtable;
#endif
